function get_ascension_automation_settings()
	local tbl = {
		ignore_buffs = {
			["A Buff To Ignore"] = true,
		},
		slimeling_feed_items = {
			"snapdragon pistil", "elephant stinger",
			"spooky stick",
			"diamond-studded cane", "leather mask", "flaming crutch", "infernal insoles", "infernal fife",
			"Knob Goblin scimitar", "Knob Goblin pants", "Knob Goblin tongs", "viking helmet",
			"spiked femur", "lihc face", "rusty grave robbing shovel", "bone flute",
			"knob bugle",
			"cornuthaum", "vorpal blade", "magic whistle", "ninja hot pants",
			"ASCII shirt",
			"crowbarrr", "Jolly Roger charrrm bracelet",
			"glowing red eye", "magilaser blastercannon", "titanium assault umbrella", "armgun", "ridiculously huge sword", "ocarina of space", "amulet of extreme plot significance",
			"rave whistle",
			"black helmet", "black sword", "black greaves",
			"leotarrrd", "grassy cutlass",
			"batblade",
			"antique helmet", "antique spear", "antique shield", "antique greaves",
			"broken sword",
		},
		slimeling_feed_except_one = {
			{ "leather chaps", },
			{ "wonderwall shield", },
			{ "black shield", },
			{ "snake shield", },
			{ "oversized pizza cutter", "huge spoon", },
			{ "hors d'oeuvre tray", },
			{ "hot plate", "coffin lid", },
			{ "tap shoes", },
			{ "worn tophat", "wolf mask", "cornuthaum", },
			{ "dead guy's watch", },
			{ "disturbing fanfic", },
			{ "4-dimensional guitar", },
			{ "mesh cap", },
		},
		use_items = {
			"chest of the Bonerdagon",
			"small box", "large box", "dead mimic",
			"canopic jar",
			"old coin purse", "old leather wallet",
			"Warm Subject gift certificate",
			"black pension check",
			"fat wallet",
			"ancient vinyl coin purse",
			"briefcase",
			"astral hot dog dinner", "astral six-pack", "carton of astral energy drinks",
		},
		sell_items = {
			"meat paste", "meat stack", "dense meat stack",
			"magicalness-in-a-can", "concentrated magicalness pill",
			"moxie weed", "giant moxie weed",
			"strongness elixir", "enchanted barbell",
			"bit-o-cactus", "handful of moss", "suntan lotion of moxiousness", "ancient protein powder",
			"ironic jogging shorts",
			"spooky shrunken head", "bowl of cottage cheese",
			"fat stacks of cash",
			"rat appendix", "batgut", "catgut",
			"Imp Ale", "hot katana blade", "demon skin", "cast",
			"8-ball",
			"gator skin", "decaying goldfish liver", "sewer nuggets", "bottle of sewage schnapps",
			"ghuol ears", "lihc eye", "smart skull", "ghuol egg", "ghuol guolash", "cranberries",
			"grouchy restless spirit",
			"stone of eXtreme power",
			"cocoa eggshell fragment",
			"towel", "gob of wet hair", "cardboard wakizashi",
			"phat turquoise bead", "beach glass bead", "clay peace-sign bead",
			"ballroom blintz", "royal jelly", "unidentified jerky", "mind flayer corpse",
			"procrastination potion", "probability potion",
			"drab sonata",
			"cat appendix",
			"baby killer bee",
			"rocky raccoon", "Tuesday's ruby", "mother's little helper", "happiness",
			"tip jar", "barrrnacle", "grumpy old man charrrm", "tarrrnish charrrm", "all-purpose cleaner",
			"empty Cloaca-Cola bottle", "valuable trinket",
			"enormous belt buckle",
			"hippy medical kit",
		},
		sell_except_one = {
			"yeti fur",
			"fancy bath salts",
			"leathery bat skin", "leathery cat skin", "leathery rat skin",
			"photoprotoneutron torpedo",
			"Angry Farmer candy", "plot hole", "chaos butterfly",
			"metallic A",
			"original G",
		},
		-- TODO: add a non-hardcoded place to look up equip requirements
		default_equipment = {
			hat = {
				{ name = "spangly sombrero", check = function() return (basemoxie() >= 60) and (level() < 13) end },
				{ name = "reinforced beaded headband", check = function() return (basemoxie() >= 70) end },
				{ name = "beer helmet", check = function() return (basemoxie() >= 70) end },
				{ name = "worn tophat", check = function() return (basemoxie() >= 47) end },
				{ name = "powdered wig", check = function() return (basemoxie() >= 20) end },
				"miner's helmet",
				"Van der Graaf helmet",
				"chef's hat",
				{ name = "Crown of the Goblin King", check = function() return (basemoxie() >= 20) end },
				"cornuthaum",
				"Knob Goblin elite helm",
				"mariachi hat",
				"snorkel",
			},
			shirt = {
				"astral shirt",
				{ name = "sugar shirt", check = function() return (level() < 13) end },
				{ name = "hipposkin poncho", check = function() return (basemuscle() >= 45) end },
				{ name = "yak anorak", check = function() return (basemuscle() >= 42) end },
				{ name = "goth kid t-shirt", check = function() return (level() < 13) end },
				"Grateful Undead T-shirt",
				{ name = "souvenir ski t-shirt", check = function() return (basemuscle() >= 35) end },
				"vampire cape",
			},
-- 			weapon = {
-- 				"hilarious comedy prop",
-- 			}
			pants = {
				{ name = "spangly mariachi pants", check = function() return (basemoxie() >= 60) end },
				"astral shorts",
				{ name = "leather chaps", check = function() return (basemoxie() >= 65) end },
				{ name = "distressed denim pants", check = function() return (basemoxie() >= 70) end },
				{ name = "bullet-proof corduroys", check = function() return (basemoxie() >= 70) end },
				"miner's pants",
				"swashbuckling pants",
				"Boss Bat britches",
				"Knob Goblin elite pants",
				{ name = "ninja hot pants", check = function() return (basemoxie() >= 20) end },
				"Knob Goblin pants",
				"old sweatpants",
			},
			accessories = {
				{ name = "astral belt", check = function() return (level() >= 7 or (challenge == "fist" and fist_level > 0)) and (level() < 13) end }, -- How early should we wear this?
				"astral ring",
				"astral mask",
				{ name = "shining halo", check = function() return (level() < 13) end },
				{ name = "ring of aggravate monster", check = function() return (level() < 13) end },
				{ name = "Nickel Gamma of Frugality", check = function() return (basemysticality() >= 85) end },
				"observational glasses",
				{ name = "pirate fledges", check = function() return (basemysticality() >= 60) end },
				"Cape of the Goblin King",
				{ name = "badass belt", check = function() return (basemysticality() >= 35) end },
				{ name = "shiny ring", check = function() return (basemysticality() >= 10) end },
			}
		}
	}
	local function canwear_itemname(x)
		local itemname = nil
		if type(x) == "string" then
			if have(x) then
				itemname = x
			end
		elseif type(x) == "table" then
			if have(x.name) and x.check and x.check() then
				itemname = x.name
			end
		end
		return itemname
	end
	tbl.canwear_itemname = canwear_itemname

	if have("powdered wig") and basemoxie() >= 20 then
		table.insert(tbl.sell_items, "Van der Graaf helmet")
	end
	if have("pirate fledges") then
		table.insert(tbl.sell_items, "The Big Book of Pirate Insults")
	end
	if have("intragalactic rowboat") then
		table.insert(tbl.sell_items, "awful poetry journal")
		table.insert(tbl.sell_items, "furry fur")
	end
	if meat() < 2000 then
		table.insert(tbl.sell_items, "commemorative war stein")
	end

	if skills then
		local maybe_ignore_skills = {
			["Musk of the Moose"] = "Musk of the Moose",
			["A Few Extra Pounds"] = "Holiday Weight Gain",
			["Ghostly Shell"] = "Ghostly Shell",
			["Astral Shell"] = "Astral Shell",
			["Empathy"] = "Empathy of the Newt",
			["Curiosity of Br'er Tarrypin"] = "Curiosity of Br'er Tarrypin",
			["Leash of Linguini"] = "Leash of Linguini",
			["Springy Fusilli"] = "Springy Fusilli",
			["Smooth Movements"] = "Smooth Movement",
			["Power Ballad of the Arrowsmith"] = "The Power Ballad of the Arrowsmith",
			["Polka of Plenty"] = "The Polka of Plenty",
			["The Sonata of Sneakiness"] = "The Sonata of Sneakiness",
			["Carlweather's Cantata of Confrontation"] = "Carlweather's Cantata of Confrontation",
			["Spirit of Bacon Grease"] = "Flavour of Magic",
			["Spirit of Garlic"] = "Flavour of Magic",
			["Spirit of Peppermint"] = "Flavour of Magic",
			["Jalape&ntilde;o Saucesphere"] = "Jalape&ntilde;o Saucesphere",
			["Jaba&ntilde;ero Saucesphere"] = "Jaba&ntilde;ero Saucesphere",
		}
		for x, y in pairs(maybe_ignore_skills) do
			if not skills[y] then
				tbl.ignore_buffs[x] = true
			end
		end
	end

	return tbl
end
