-- check for valid pwd!

text = nil
url = nil

if can_read_state() ~= "yes" then
	return
end

if not params then
	print("error, params is", params)
	print("requestpath", requestpath)
end

dofile("scripts/base/util.lua")

path = requestpath -- temporary workaround for backwards compatibility
query = requestquery -- temporary workaround for backwards compatibility

input_params = params
params = parse_params(params)

local interceptors = {}

local function add_interceptor_raw(scriptname, file, func)
	if not interceptors[file] then interceptors[file] = {} end
	table.insert(interceptors[file], { scriptname = scriptname, f = func })
end

function __add_interceptor_function(file, func)
	add_interceptor_raw(name, file, func)
end

-- TODO: name isn't tracked anymore, is it?
load_script_files {
	add_processor = function () end,
	add_printer = function () end,
	add_choice_text_conditional = function () end,
	add_choice_text = function () end,
	add_choice_itemtext = function () end,
	add_choice_function = function () end,
	add_automator = function () end,
	add_interceptor = __add_interceptor_function,
}

setup_functions()

function determine_cellar_wines()
	if not ascension["zone.manor.wines needed"] then
		get_page("/desc_item.php", { whichitem = "278847834" })
		get_page("/desc_item.php", { whichitem = "163456429" })
		get_page("/desc_item.php", { whichitem = "147519269" })
		get_page("/desc_item.php", { whichitem = "905945394" })
		get_page("/desc_item.php", { whichitem = "289748376" })
		get_page("/desc_item.php", { whichitem = "625138517" })
		get_page("/manor3.php", { place = "goblet" })
	end
end

if requestpath == "/manor3.php" then
	determine_cellar_wines()
end

if requestpath == "/cave.php" then
	if params.action == "door4" then
		get_page("/desc_item.php", { whichitem = "776620628" })
		get_page("/desc_item.php", { whichitem = "298163869" })
		get_page("/desc_item.php", { whichitem = "564255755" })
		get_page("/desc_item.php", { whichitem = "411336587" })
		get_page("/desc_item.php", { whichitem = "626990413" })
		get_page("/desc_item.php", { whichitem = "647825911" })
		get_page("/desc_item.php", { whichitem = "153915446" })
		get_page("/desc_item.php", { whichitem = "148513878" })
	end
end

function automate_tiles()
	local function choose(tile)
		return post_page("/tiles.php", { action = "jump", whichtile = tile })
	end
	choose(4)
	choose(6)
	choose(3)
	choose(5)
	choose(7)
	choose(6)
	return choose(3)
end

if requestpath == "/automate-tiles" then
	text, url = automate_tiles()
end

-- 			let inrunoption = case choice of
-- 				21 -> 2 -- not trapped in the wrong body
-- 				46 -> 3 -- fight vampire, maybe doubtful?
-- 				105 -> 1 -- gaze into mirror in bathroom
-- 				108 -> 4 -- walk away from craps
-- 				109 -> 1 -- fight hobo
-- 				110 -> 4 -- introduce them to avantgarde
-- 				113 -> 2 -- fight knob goblin chef
-- 				118 -> 2 -- don't do wounded guard quest
-- 				120 -> 4 -- ennui outta here
-- 				123 -> 2 -- raise your hands in hidden temple
-- 				177 -> 5 -- blackberry cobbler, leave
-- 				402 -> 2 -- don't hold a grudge in bathroom, gain myst
-- 				otherwise -> -1
-- 			let aftercoreoption = case choice of
-- 				9 -> 3 -- leave the wheel alone in the castle
-- 				10 -> 3 -- leave the wheel alone in the castle
-- 				11 -> 3 -- leave the wheel alone in the castle
-- 				12 -> 3 -- leave the wheel alone in the castle
-- 				21 -> -1 -- trapped in the wrong body?
-- 				26 -> 2 -- take the scorched path
-- 				28 -> 2 -- investigate the moist crater for spices
-- 				89 -> 2 -- fight TT knight in the gallery
-- 				90 -> 2 -- watch the dancers in ballroom
-- 				112 -> 2 -- no time for harold's bell
-- 				178 -> 2 -- blow popsicle stand in airship
-- 				182 -> 1 -- fight in the airship
-- 				207 -> 2 -- leave hot door alone in burnbarrel
-- 				213 -> 2 -- leave piping hot in burnbarrel
-- 				214 -> 1 -- kick stuff into the hole in the heap
-- 				216 -> 2 -- begone from the compostal service
-- 				otherwise -> inrunoption

if requestpath == "/inv_use.php" then
	if character["automate simple tasks"] == "yes" then
	-- 	for a, b in pairs(params) do
	-- 		print("use params:", a, b)
	-- 	end
		item = get_item_data_by_id(tonumber(params.whichitem))
		if item then
	-- 		for a, b in pairs(item) do
	-- 			print("use item:", a, b)
	-- 		end
			if item.name == "Degrassi Knoll shopping list" then
				stuff = {}
				stuff["bitchin' meatcar"] = { "meat engine", "dope wheels" }
				stuff["dope wheels"] = { "tires", "sweet rims" }
				stuff["meat engine"] = { "cog and sprocket assembly", "full meat tank" }
				stuff["cog and sprocket assembly"] = { "sprocket assembly", "cog" }
				stuff["sprocket assembly"] = { "spring", "sprocket" }
				stuff["full meat tank"] = { "empty meat tank", "meat stack" }
				can_buy = {}
				if moonsign_area() == "Degrassi Knoll" then
					can_buy["tires"] = true
					can_buy["cog"] = true
					can_buy["spring"] = true
					can_buy["sprocket"] = true
					can_buy["empty meat tank"] = true
				end
				can_buy["meat stack"] = true
				function combine_tables(a, b)
					ret = {}
					for x, y in pairs(a) do table.insert(ret, y) end
					for x, y in pairs(b) do table.insert(ret, y) end
					return ret
				end
				function try_to_create(name)
	-- 					print("try_to_create", name)
					if have(name) then
						return { have = { name }, buy = {}, missing = {}, order = {} }
					end
					if can_buy[name] then
	-- 						print("buying", name)
						return { have = {}, buy = { name }, missing = {}, order = {} }
					end
					if stuff[name] then
	-- 						print(name, "pasting", stuff[name][1], stuff[name][2])
						local a = try_to_create(stuff[name][1])
						local b = try_to_create(stuff[name][2])
						local have = combine_tables(a.have, b.have)
						local buy = combine_tables(a.buy, b.buy)
						local missing = combine_tables(a.missing, b.missing)
						local order = combine_tables(a.order, b.order)
						table.insert(order, { stuff[name][1], stuff[name][2] })
	-- 						print(name, "pasted", printstr(have), printstr(buy), printstr(missing), printstr(order))
						return { have = have, buy = buy, missing = missing, order = order }
					end
	-- 					print("missing", name)
					return { have = {}, buy = {}, missing = { name }, order = {} }
				end
				meatcar = try_to_create("bitchin' meatcar")
	-- 				print("need to buy", printstr(meatcar.buy))
	-- 				print("missing", printstr(meatcar.missing))
				if (next(meatcar.missing)) then
					local missing_list = {}
					for a, b in pairs(meatcar.missing) do table.insert(missing_list, [[<span style="color: darkorange;">]] .. b .. [[</span>]]) end
					for a, b in pairs(meatcar.buy) do table.insert(missing_list, [[<span style="color: gray;">]] .. b .. [[</span>]]) end
					for a, b in pairs(meatcar.have) do table.insert(missing_list, [[<span style="color: green;">]] .. b .. [[</span>]]) end
					text, url = get_page("/inv_use.php", params):gsub("<blockquote>.+</blockquote>", "<blockquote>Needed items:<p><blockquote><p>" .. table.concat(missing_list, "<br>") .. "</p></blockquote></blockquote>")
				else
					function buy_from_general_store(name)
						get_page("/store.php", { phash = params.pwd, buying = 1, whichitem = get_itemid(name), howmany = 1, whichstore = "5", ajax = 1, action = "buyitem" })
					end

					for x, name in pairs(meatcar.buy) do
	-- 						print("buying", name)
						if name == "meat stack" then
							get_page("/inventory.php", { quantity = 1, action = "makestuff", pwd = params.pwd, whichitem = get_itemid(name), ajax = 1 })
						else
							buy_from_general_store(name)
						end
					end
					for x, name in pairs(meatcar.order) do
	-- 						print("pasting", name[1], name[2])
						meatpaste_items(name[1], name[2])
					end

					get_page("/town_right.php", { place = "untinker" })
					get_page("/knoll.php", { place = "smith" })
					get_page("/town_right.php", { place = "untinker" })
					get_page("/guild.php", { place = "paco" }) -- need the topmenu refreshed from this
					text, url = get_page("/inv_use.php", params)
					post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = get_itemid("bitchin' meatcar") })
					post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = get_itemid("dope wheels") })

					text = "<script>parent.menupane.location.href=parent.menupane.location.href;</script>" .. text -- do in a prettier way?
				end
			end
			if item.name == "black market map" then -- TODO: make this an automator?
				-- TODO: add Bee path support?
				local famid = familiarid()
				if have("broken wings") and have("sunken eyes") then
					meatpaste_items("broken wings", "sunken eyes")
				end
				get_page("/inv_familiar.php", { whichitem = get_itemid("reassembled blackbird"), ajax = 1, pwd = params.pwd })
				get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = 59 }) -- blackbird
				text, url = get_page(requestpath, params)
				get_page("/familiar.php", { action = "newfam", ajax = 1, newfam = famid })
			end
		end
	end
end

for _, x in ipairs(interceptors[requestpath] or {}) do
	local t, u = x.f()
	if t then
		return t, u
	end
end

if text then
	return text, url
else
	return raw_submit_page(request_type, requestpath, parse_params_raw(input_params))
end
